﻿
using System;
using System.Collections.Generic;
using System.Linq;
using Wisej.Web;

namespace TestDataSource
{
    public partial class Window1 : Form
    {
        private List<Employee> _list;
        public Window1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            _list = new List<Employee>();

            for (int i = 0; i < 125; i++)
            {
                Employee emp = new Employee(RandomString(i));
                _list.Add(emp);
            }


            dataGridView1.BeginUpdate();
            dataGridView1.DataSource = null;
            dataGridView1.DataSource = _list;
            dataGridView1.EndUpdate();

        }

        private Random random = new Random();

        public string RandomString(int length)
        {
            const string chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            return new string(Enumerable.Repeat(chars, length)
              .Select(s => s[random.Next(s.Length)]).ToArray());
        }

        private void Window1_Load(object sender, EventArgs e)
        {
            _list = new List<Employee>();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            dataGridView1.BeginUpdate();

            _list = _list.OrderByDescending(x => x.Name).ToList();

            dataGridView1.DataSource = null;
            dataGridView1.DataSource = _list;

            dataGridView1.EndUpdate();
        }

        private void button3_Click(object sender, EventArgs e)
        {

            dataGridView1.BeginUpdate();
            _list.Clear();
            dataGridView1.DataSource = null;
            dataGridView1.DataSource = _list;
            dataGridView1.EndUpdate();
        }
    }

    public class Employee
    {
        public Employee(string name)
        {
            Name = name;
        }

        public string Name { get; set; }
    }
}
